-- Speccy's Main Lua
-- Speccy - 2022

-- Don't take stuff from this Lua without getting my permission first.

-- SRB2Persona in this script? Nahhhh..

if srb2p then return end

-- Misc. variables.

local skinchanged = true

-- Console variable for the level up jingle, the one for the hud is near the end of file.

local speccy_levelupjingle = CV_RegisterVar({
	name = "speccy_levelupjingle",
	defaultvalue = 1,
	flags = nil,
	PossibleValue = CV_OnOff,
	func = nil
})

-- Leveling function, pretty nice. It's from Disgea by the way... just with some edits.

rawset(_G, "newExpRequirement", function(level)
	return FixedRound((2621/12) * ((level+1) ^ 3) + (52428/12) * ((level+1) ^ 2) + (131070/12) * (level+1))/(65535/12)
end)

rawset(_G, "levelSpeccyUp", function(p)
	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" and p.speccy then
			if p.speccy.level >= 200 then
				p.speccy.exp = p.speccy.expreq
				return
			end
		
			if speccy_levelupjingle.value then
				S_StartSound(p.mo, sfx_lvup, p)
			end
			p.speccy.level = $ + 1
			p.speccy.totalexp = $ + p.speccy.exp
			p.speccy.exp = $ - p.speccy.expreq
			p.speccy.expreq = newExpRequirement(p.speccy.level)
			p.speccy.maxhp = $ + (p.speccy.maxhp % (p.speccy.level+5)%p.speccy.maxhp)
			p.speccy.hp = p.speccy.maxhp
			if not (p.speccy.level % 5) then
				if not p.speccy.newnormalspeed then
					p.speccy.newnormalspeed = skins["speccy"].normalspeed
				end
				p.speccy.newnormalspeed = $ + (p.speccy.level%2)*FRACUNIT
			end
			if p.speccy.level == 25 then
				p.speccy.tip = 1
				p.speccy.tipdisplay = 3*TICRATE
			elseif p.speccy.level == 30 and skins["samus"] ~= nil then
				p.speccy.tip = 2
				p.speccy.tipdisplay = 3*TICRATE
			end
			if p.speccy.exp < 0 then
				p.speccy.exp = 0
			end
		else
			error("cannot level up if you're not Speccy!", 2)
		end
	else
		error("cannot level up if you don't exist!", 2)
	end
end)

COM_AddCommand("levelup", function(p, arg)
	if tonumber(arg) ~= nil then
		arg = tonumber(arg)
	else
		arg = 1
	end
	
	for i=1,tonumber(arg) do
		levelSpeccyUp(p)
	end
end)

-- Boss Table, supports custom bosses by adding them after Speccy... maybe you can add them before, I don't know, maybe by rawsetting it yourself.
-- This is carried over from before the re-script.

-- Layout: [MT_MOBJNAME] = {"Boss Name", Damage, EXP reward}

rawset(_G, "adventureBossTable", {
	[MT_EGGMOBILE] = {"Egg Zapper", 25, 75},
	[MT_EGGMOBILE2] = {"Egg Slimer", 35, 150},
	[MT_EGGMOBILE3] = {"Sea Egg", 45, 175},
	[MT_EGGMOBILE4] = {"Egg Colosseum", 50, 250},
	[MT_FANG] = {"Fang the Sniper", 35, 500},
	[MT_METALSONIC_BATTLE] = {"Metal Sonic", 50, 750},
	[MT_CYBRAKDEMON] = {"Black Eggman", 100, 1000},
})

rawset(_G, "adventureInfTable", {
	[MT_CORK] = 25,
	[MT_CYBRAKDEMON_MISSILE] = 50,
	[MT_BLACKEGGMAN_MISSILE] = 50,
	[MT_CYBRAKDEMON_VILE_EXPLOSION] = 75,
	[MT_CYBRAKDEMON_FLAMESHOT] = 25,
	[MT_CYBRAKDEMON_FLAMEREST] = 25,
	[MT_CYBRAKDEMON_NAPALM_FLAMES] = 25,
	[MT_FBOMB] = 40,
	[MT_LASER] = 35,
	[MT_EGGMOBILE_BALL] = 25,
	[MT_EGGMOBILE_FIRE] = 25,
	[MT_TORPEDO] = 35,
	[MT_ENERGYBALL] = 45,
	[MT_TURRETLASER] = 15,
	[MT_SHOCKWAVE] = 35,
	[MT_EGGMOBILE4_MACE] = 45,
	[MT_GOOP] = 15,
	[MT_JETTBULLET] = 25,
	[MT_MINE] = 35,
	[MT_CYBRAKDEMON_ELECTRIC_BARRIER] = 100,
})

rawset(_G, "adventureEXPTable", {
	[MT_RING] = 1,
	[MT_FLINGRING] = 1,
	[MT_BLUESPHERE] = 5,
	[MT_TOKEN] = 100,
	[MT_RING_BOX] = 10,
	[MT_1UP_BOX] = 50,
	[MT_EGGMAN_BOX] = -25,
})

rawset(_G, "adventureHealTable", {
	[MT_RING] = 1,
	[MT_RING_BOX] = 10,
	[MT_1UP_BOX] = 50,
	[MT_BLUESPHERE] = 5,
	[MT_TOKEN] = 100
})

rawset(_G, "SuperJump", function(p)
	if p.speccy.crouch and P_IsObjectOnGround(p.mo) then
		p.speccy.superjumpcharge = $ + 1
		if p.speccy.superjumpcharge >= 35
			p.mo.colorized = true
			if p.speccy.superjumpcharge == 35 then
				S_StartSound(p.mo, sfx_s3ka2, p)
			end
			if (p.cmd.buttons & BT_JUMP) then
				p.speccy.crouch = false
				p.speccy.shouldcrouch = false
				p.speccy.superjumpcharge = 0
				p.speccy.superjumpstart = true
			elseif (p.cmd.buttons & BT_USE) then
				p.speccy.crouch = false
				p.speccy.shouldcrouch = false
				p.speccy.superjumpcharge = 0
				p.speccy.spinburststart = true
			end
		end
	elseif P_IsObjectOnGround(p.mo) and p.speccy.superjumpstart then
		for i=0,7 do
			local skid = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
			if skid and skid.valid then
				skid.angle = FixedAngle(i*(45*FRACUNIT))
				P_InstaThrust(skid, skid.angle, 4*FRACUNIT)
			end
		end
		if p.powers[pw_spacetime] or p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 6*p.jumpfactor, false)
		else
			P_SetObjectMomZ(p.mo, 16*p.jumpfactor, false)
		end
		p.pflags = $|PF_JUMPED
		p.mo.colorized = false
		p.normalspeed = skins[p.mo.skin].normalspeed
		p.mo.state = S_PLAY_ROLL
		p.speccy.superjumpstart = false
		p.speccy.superjumping = true
		p.speccy.superjumpcharge = 0
	elseif P_IsObjectOnGround(p.mo) and p.speccy.spinburststart then
		for i=1,8 do
			P_SpawnSkidDust(p, p.mo.radius+p.mo.radius/2, false)
		end
		if p.powers[pw_spacetime] or p.powers[pw_underwater] then
			P_InstaThrust(p.mo, p.mo.angle, 32*FRACUNIT)
		else
			P_InstaThrust(p.mo, p.mo.angle, 64*FRACUNIT)
		end
		p.pflags = $|PF_SPINNING
		p.mo.colorized = false
		p.normalspeed = skins[p.mo.skin].normalspeed
		p.mo.state = S_PLAY_ROLL
		p.speccy.spinburststart = false
		p.speccy.superjumpcharge = 0
	else
		p.mo.colorized = false
		p.speccy.superjumping = false
		p.speccy.superjumpstart = false
		p.speccy.spinburststart = false
		p.speccy.superjumpcharge = 0
	end
end)

rawset(_G, "adventureAbilityTable", {
	{25, SuperJump}, -- Also contains Spin Burst-
})

-- Shop Table, you can purchase items here.

rawset(_G, "adventureShopTable", {})

-- Saving Data, saving your config is done in another function.

rawset(_G, "saveSpeccyData", function(p)
	if netgame then return end
	local array = {
	
		-- Level & EXP Stats
	
		p.speccy.level,
		p.speccy.exp,
		p.speccy.expreq,
		p.speccy.totalexp,
		p.speccy.multiplier,
		
		-- Speccy Gameplay Stats
		
		p.speccy.hp,
		p.speccy.maxhp,
		p.speccy.supertime,
	
		-- Speccy Chao Stats
	
		p.speccy.chaolevel,
		p.speccy.chaoexp,
		p.speccy.chaoexpreq,
		p.speccy.chaobonus,
		p.speccy.chaorange,
		
		-- Currency & Purchases.
		
		p.speccy.rings,
		p.speccy.chaobought,
		
		-- Technically this *should* be in config, but ehh.
		
		p.speccy.crouchtype
	
	}
	
	local savestring = ""
	
	for i=1, #array do
		savestring = $ .. tostring(array[i]) .. "\n"
	end
	
	local save = io.openlocal("client/speccy/savedata.dat", "w+")
	save:write(savestring)
	save:flush()
	save:close()
	
end)

rawset(_G, "loadSpeccyData", function(p)
	if netgame then return end
	local array = {}
	local save = io.openlocal("client/speccy/savedata.dat", "r+")
	
	for line in save:lines() do
		table.insert(array, tonumber(line))
	end
	
	-- Level & EXP Stats
	
	p.speccy.level = array[1]
	p.speccy.exp = array[2]
	p.speccy.expreq = array[3]
	p.speccy.totalexp = array[4]
	p.speccy.multiplier = array[5]
		
	-- Speccy Gameplay Stats
		
	p.speccy.hp = array[6]
	p.speccy.maxhp = array[7]
	p.speccy.supertime = array[8]
	
	-- Speccy Chao Stats
	
	p.speccy.chaolevel = array[9]
	p.speccy.chaoexp = array[10]
	p.speccy.chaoexpreq = array[11]
	p.speccy.chaobonus = array[12]
	p.speccy.chaorange = array[13]
	
	-- Currency & Purchases.
		
	p.speccy.rings = array[14]
	p.speccy.chaobought = array[15]
	
	-- Technically this *should* be in config, but ehh.
	
	p.speccy.crouchtype = array[16]
	
	save:close()
	
end)

-- Resetting Data... why would you other than if p.speccy doesn't exist...? Oh, right, if you hate yourself. Or if you're a map pack creator, and hate players. (or just want a fair experience) Or if you're a normal person who just felt the need to start from the beginning. Yes, I'm typing a lot, just ignore this. Hmm, so uhm, when will I make that save system seeing as that's what this is *partially* for. Hmm, maybe now-

rawset(_G, "resetSpeccyVars", function(p, arg)
	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" then
			p.speccy = {}
			p.speccy.maxhp = 100
			p.speccy.hp = p.speccy.maxhp
			p.speccy.level = 1
			p.speccy.exp = 0
			p.speccy.expreq = newExpRequirement(p.speccy.level)
			p.speccy.totalexp = 0
			p.speccy.multiplier = FRACUNIT
			p.speccy.crouchtype = 1
			p.speccy.supertime = 30*TICRATE
			p.speccy.jumps = 0
			p.speccy.rings = 0
			p.speccy.superjumpcharge = 0
			p.speccy.superjumpstart = false
			p.speccy.superjumping = false
			p.speccy.spinburststart = false

			-- Chao.

			p.speccy.chaolevel = 1
			p.speccy.chaoexp = 0
			p.speccy.chaoexpreq = 5
			p.speccy.chaobonus = 0
			p.speccy.chaorange = 128
			p.speccy.chaobought = 0
			
			if (not netgame) and (not modeattacking) and (not (marathonmode & MA_RUNNING)) and (not (marathonmode & MA_INIT)) then
				if arg or io.openlocal("client/speccy/savedata.dat", "r+") == nil then
					saveSpeccyData(p)
				elseif io.openlocal("client/speccy/savedata.dat", "r+") ~= nil then
					loadSpeccyData(p)
				end
			end
		else
			error("cannot run resetSpeccyVars if you're not Speccy!", 2)
		end
	else
		error("cannot run resetSpeccyVars if you don't exist!", 2)
	end
end)

rawset(_G, "shouldSpeccyCrouch", function(p, arg)

	if G_IsSpecialStage(gamemap) then return end

	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" then
		
			if p.speccy.superjumpstart or p.speccy.superjumping or p.speccy.spinburststart or (p.pflags & PF_SPINNING) or p.speccy.diving then return false end
		
			if arg then
				return true
			else
				if p.speccy.crouchtype == 1 then
					if (p.cmd.buttons & BT_CUSTOM1) and P_IsObjectOnGround(p.mo) then
						return true
					else
						return false
					end
				elseif p.speccy.shouldcrouch and P_IsObjectOnGround(p.mo) then
					return true
				else
					return false
				end
			end
		else
			return false
		end
	else
		return false
	end
end)

COM_AddCommand("speccy_crouchtype", function(p, arg)
	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" and p.speccy then
			if tonumber(arg) ~= nil then
			
				arg = tonumber(arg)
			
				if arg > 0 and arg <= 2 then
					p.speccy.crouchtype = arg
				else
					CONS_Printf(p, "Invalid crouch type.")
				end
			else
				CONS_Printf(p, "\nspeccy_crouchtype:\n\n- Usage: speccy_crouchtype <number>\n\nTypes:\n\n- 1: Hold to crouch.\n- 2: Tap to crouch.\n")
			end
		end
	end
end)

addHook("PlayerThink", function(p)

	if G_IsSpecialStage(gamemap) then return end

	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" then
			if p.speccy == nil then
				resetSpeccyVars(p)
			else

				p.speccy.multiplier = FRACUNIT + (((p.speccy.level*FRACUNIT)/10)+((p.scoreadd*FRACUNIT)/100) + ((emeralds*FRACUNIT)/50)*2)
			
				if p.powers[pw_super] then
					p.speccy.multiplier = $ + FRACUNIT
					if p.speccy.hp < p.speccy.maxhp then
						p.speccy.hp = $ + p.speccy.maxhp/100
					else
						p.speccy.hp = p.speccy.maxhp
					end
					p.rings = 50
					p.speccy.supertime = $-1
					if (p.speccy.supertime <= 0) or ((p.cmd.buttons & BT_CUSTOM1) and (p.pflags & PF_JUMPED)) then
						p.powers[pw_super] = 0
						if p.speccy.newnormalspeed then
							p.normalspeed = p.speccy.newnormalspeed
						else
							p.normalspeed = skins["speccy"].normalspeed
						end
						p.jumpfactor = skins["speccy"].jumpfactor
						p.mo.color = p.skincolor
						COM_BufInsertText(p, "tunes -default")
					end
				end
				
				if emeralds == 127 and p.speed < 4*FRACUNIT then
					p.rings = 50
				else
					p.rings = 0
				end
			
				if p.speccy.exp >= p.speccy.expreq then
					levelSpeccyUp(p)
				end
				
				if p.speccy.level >= 200 and p.speccy.exp >= p.speccy.expreq then
					if not (p.speccy.shades and p.speccy.shades.valid) then
						p.speccy.shades = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SHADES)
					else
						if not (p.mo.flags2 & MF2_OBJECTFLIP) then
							p.speccy.shades.flags2 = $ & ~MF2_OBJECTFLIP
							P_TeleportMove(p.speccy.shades, p.mo.x + p.mo.momx + FixedMul(1*FRACUNIT, cos(p.drawangle)), p.mo.y + p.mo.momy + FixedMul(1*FRACUNIT, sin(p.drawangle)), p.mo.z + p.mo.momz + p.mo.height/2)
						else
							p.speccy.shades.flags2 = $|MF2_OBJECTFLIP
							P_TeleportMove(p.speccy.shades, p.mo.x + p.mo.momx + FixedMul(1*FRACUNIT, cos(p.drawangle)), p.mo.y + p.mo.momy + FixedMul(1*FRACUNIT, sin(p.drawangle)), p.mo.z + p.mo.momz + p.mo.height/2)
						end
						if camera.chase then
							p.speccy.shades.flags2 = $ & ~MF2_DONTDRAW
						else
							p.speccy.shades.flags2 = $|MF2_DONTDRAW
						end
						p.speccy.shades.momz = 0
						p.speccy.shades.angle = p.drawangle
						p.speccy.shades.scale = FRACUNIT/2
					end
				elseif (p.speccy.shades and p.speccy.shades.valid) then
					P_RemoveMobj(p.speccy.shades)
				end
				
				if p.playerstate == PST_REBORN and p.speccy.hp < p.speccy.maxhp / 2 then
					p.speccy.hp = p.speccy.maxhp / 2
				end
				
				if P_IsObjectOnGround(p.mo) then
								
					if p.speccy.crouchtype == 2 then
					
						if not (p.cmd.buttons & BT_CUSTOM1) then
							p.speccy.crouchready = true
							p.speccy.crouchtap = false
						elseif p.speccy.crouchready then
							p.speccy.crouchready = false
							p.speccy.crouchtap = true
						else
							p.speccy.crouchtap = false
						end
					
						if p.speccy.crouchtap then
							if p.speccy.shouldcrouch then
								p.speccy.shouldcrouch = false
							else
								p.speccy.shouldcrouch = true
							end
						end
					
					end
				
					if shouldSpeccyCrouch(p, false) then
						p.speccy.crouch = true
						p.pflags = $|PF_JUMPSTASIS
						p.mo.state = S_SPECCY_CROUCH
						p.normalspeed = 4*FRACUNIT
					else
						p.speccy.superjumping = false
						p.speccy.shouldcrouch = false
						if p.speccy.crouch then
							p.speccy.crouch = false
							p.mo.state = S_PLAY_STND
							p.pflags = $ & ~PF_JUMPSTASIS
							p.normalspeed = skins[p.mo.skin].normalspeed
						end
					end
				else
					p.speccy.shouldcrouch = false
					p.speccy.superjumping = false
					if p.speccy.crouch then
						p.speccy.crouch = false
						p.mo.state = S_PLAY_FALL
						p.pflags = $ & ~PF_JUMPSTASIS
						p.normalspeed = skins[p.mo.skin].normalspeed
					end
				end
				
				for s in mobjs.iterate() do
					if s.type == MT_METROID then
						if s.latchsuck and (s.latchtarget and s.latchtarget.valid) then
							if s.latchtarget.player == p and p.speccy.hp > 1 then
								if p.speccy.crouch and p.speccy.level >= 30 then
									s.latchsuck = 0
									s.stuntroid = 120
									s.actiontroid = P_RandomRange(37, 65)
									s.latchtarget = nil
									for d = 1,18
										if (P_TryMove(s, s.x+FixedMul(-50*FRACUNIT, cos(ANG20*d)), s.y+FixedMul(-50*FRACUNIT, sin (ANG20*d)), false))
											return
										end
									end
								end
								s.survivemetroid = 2
								if (not p.powers[pw_flashing]) and (not p.speccy.crouch) then
									p.speccy.hp = $ - FixedRound(p.speccy.level/2*FRACUNIT)/FRACUNIT
									p.powers[pw_flashing] = 5
								end
								if p.mo.state == S_PLAY_MELEE then
									s.momz = 2*FRACUNIT s.momx = p.mo.momx*-1 s.momy = p.mo.momy*-1
									S_StartSound(s, sfx_mtrd2)
									s.stuntroid = 120
									s.latchsuck = 0
									s.actiontroid = P_RandomRange(37, 65)
									P_SamFP(p, PAL_RECYCLE, 3)
									s.latchtarget = nil
									for d = 1,18
										if (P_TryMove(s, s.x+FixedMul(-50*FRACUNIT, cos(ANG20*d)), s.y+FixedMul(-50*FRACUNIT, sin (ANG20*d)), false))
											return
										end
									end
								end
							elseif p.speccy.hp < 1 then
								P_DamageMobj(p.mo, s, s, 1, DMG_INSTAKILL)
							end
						end
					end
				end
				
				if p.speccy.hp < 0 then
					p.speccy.hp = 0
				elseif p.speccy.hp > p.speccy.maxhp and not (p.speccy.shades and p.speccy.shades.valid) then
					p.speccy.hp = p.speccy.maxhp
				elseif p.speccy.hp > p.speccy.maxhp + p.speccy.maxhp/2 and (p.speccy.shades and p.speccy.shades.valid) then
					p.speccy.hp = p.speccy.maxhp + p.speccy.maxhp/2
				end
				
				if leveltime <= 0 then
					if p.speccy.shades and p.speccy.shades.valid and p.speccy.hp <= p.speccy.maxhp then
						local bossexists = false
						for mobj in mobjs.iterate() do
							if mobj.flags & MF_BOSS then
								bossexists = true
							end
						end
						if bossexists then
							p.speccy.hp = $ + p.speccy.maxhp/2
						end
					else
						if p.speccy.hp <= 0 then
							p.speccy.hp = p.speccy.maxhp/2
						end
					end
				end
				
				if p.speccy.newnormalspeed and not p.speccy.crouch then
					p.normalspeed = p.speccy.newnormalspeed
				end
				
				for i=1,#adventureAbilityTable do
					if p.speccy.level >= adventureAbilityTable[i][1] then
						adventureAbilityTable[i][2](p)
					end
				end
				
				if p.speccy.diving then
					if (p.pflags & PF_JUMPED) or (p.mo.eflags & MFE_SPRUNG) or abs(p.speed) <= FRACUNIT or P_PlayerInPain(p) then
						p.pflags = $ & ~PF_SPINNING
						p.speccy.diving = false
						if P_IsObjectOnGround(p.mo) then
							p.mo.state = S_PLAY_WALK
						end
						return
					end
					
					p.pflags = $|PF_SPINNING
					p.mo.state = S_SPECCY_DIVE
					if P_IsObjectOnGround(p.mo) then
						P_SpawnSkidDust(p, p.mo.radius/2, true)
					end
				end
				
			end
		end
		
		if p.lastskin == "speccy" and p.mo.skin ~= "speccy" then
			skinchanged = true
		end
		
		p.lastskin = p.mo.skin
		
		if not (p.cmd.buttons & BT_USE) then
			p.speccy.spinready = true
			p.speccy.spintap = false
		elseif p.speccy.spinready then
			p.speccy.spinready = false
			p.speccy.spintap = true
		else
			p.speccy.spintap = false
		end
		
	end
end)

addHook("AbilitySpecial", function(p)
	if p.mo.skin ~= "speccy" then return end
	if p.speccy.superjumpstart then return end
	if p.speccy.superjumping then return end
	if not (p.pflags & PF_THOKKED) then
		if p.powers[pw_spacetime] or p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 4*p.jumpfactor, false)
		else
			P_SetObjectMomZ(p.mo, 10*p.jumpfactor, false)
		end
		for i=0,7 do
			local skid = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
			if skid and skid.valid then
				skid.angle = FixedAngle(i*(45*FRACUNIT))
				P_InstaThrust(skid, skid.angle, 4*FRACUNIT)
			end
		end
		S_StartSound(p.mo, sfx_jump)
		p.mo.state = S_PLAY_JUMP
		p.pflags = $|PF_THOKKED
	end
end)

addHook("JumpSpecial", function(p)
	if p.mo.skin ~= "speccy" then return end
	if not p.speccy then return end
	
	if p.speccy.diving and P_IsObjectOnGround(p.mo) then
		if p.powers[pw_spacetime] or p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 2*p.jumpfactor, false)
		else
			P_SetObjectMomZ(p.mo, 6*p.jumpfactor, false)
		end
		p.mo.state = S_PLAY_ROLL
		p.speccy.diving = false
		p.pflags = $|PF_JUMPED
		p.pflags = $ & ~PF_SPINNING
		return true
	end
end)

addHook("MobjMoveCollide", function(pmo, spring)
	if pmo and pmo.valid then
		if pmo.skin ~= "speccy" then return end
		if pmo.player and pmo.player.speccy then
			if not pmo.player.speccy.diving then return end
			if spring and spring.valid then
				if spring.flags & MF_SPRING then
					if pmo.z+pmo.height >= spring.z-8*FRACUNIT and pmo.z <= spring.z+spring.height then
						if mobjinfo[spring.type].painchance then pmo.player.pflags = $|PF_JUMPED end
						pmo.player.speccy.diving = false
						pmo.player.pflags = $ & ~PF_SPINNING
					end
				end
			end
		end
	end
end, MT_PLAYER)

addHook("SpinSpecial", function(p)
	if p.mo.skin ~= "speccy" then return end
	if not p.speccy then return end
	if p.speccy.superjumpstart then return end
	if p.speccy.superjumping then return end
	if p.pflags & PF_SPINNING then return end
	if P_PlayerInPain(p) then return end
	if p.speccy.diving then return end
	if p.speccy.crouch then return end
	if p.mo.eflags & MFE_SPRUNG then return end
	if not p.speccy.spintap then return end
	
	if p.speed >= 4*FRACUNIT then
		p.pflags = $ & ~PF_JUMPED
		p.pflags = $|PF_SPINNING
		p.mo.state = S_SPECCY_DIVE
		p.speccy.diveangle = p.drawangle
		if p.powers[pw_spacetime] or p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 2*p.jumpfactor, false)
			P_InstaThrust(p.mo, p.speccy.diveangle, p.speed/2 + 2*FRACUNIT)
		else
			P_SetObjectMomZ(p.mo, 6*p.jumpfactor, false)
			P_InstaThrust(p.mo, p.speccy.diveangle, p.speed + 4*FRACUNIT)
		end
		p.speccy.diving = true
	end
end)

addHook("PlayerCanDamage", function(p)
	if p.mo.skin ~= "speccy" then return end
	if not p.speccy then return end
	if p.speccy.diving then return true end
end)

addHook("MobjMoveBlocked", function(pmo, mobj, line)
	if pmo and pmo.valid then
		if pmo.skin ~= "speccy" then return end
		if pmo.player and pmo.player.speccy then
			if not pmo.player.speccy.diving then return end
			if line then
				if line.frontsector then
					if line.frontsector.ceilingheight >= pmo.z+pmo.height and line.frontsector.floorheight <= pmo.z then return false end
				elseif line.backsector then
					if line.backsector.ceilingheight >= pmo.z+pmo.height and line.backsector.floorheight <= pmo.z then return false end
				end
				if abs(pmo.player.speed) >= 16*FRACUNIT then
					if pmo.player.powers[pw_spacetime] or pmo.player.powers[pw_underwater] then
						P_InstaThrust(pmo, pmo.player.speccy.diveangle, (pmo.player.speed*-1)/2)
						P_SetObjectMomZ(pmo, 6*FRACUNIT, false)
					else
						P_InstaThrust(pmo, pmo.player.speccy.diveangle, (pmo.player.speed*-1)/6)
						P_SetObjectMomZ(pmo, 2*pmo.player.jumpfactor, false)
					end
					pmo.state = S_PLAY_PAIN
					pmo.player.drawangle = pmo.player.speccy.diveangle*-1
					pmo.player.speccy.diving = false
				end
			end
		end
	end
end, MT_PLAYER)

-- Crouching makes Speccy take less space, so make it true for the game too.

local function CrouchHeight(p)
	if G_IsSpecialStage(gamemap) then return end

	if not (p.mo and p.mo.valid) then 
		return false
	end

	if p.speccy and p.mo.skin == "speccy" then
		if p.speccy.crouch then
			return 18*FRACUNIT
		elseif (p.pflags & PF_SPINNING) then
			return 18*FRACUNIT
		else
			return 42*FRACUNIT
		end
	end
end

local function CrouchGap(p)

	if G_IsSpecialStage(gamemap) then return end

	if not (p.mo and p.mo.valid) then 
		return false
	end

	if p.speccy and p.mo.skin == "speccy" then
		if p.speccy.crouch then
			return true
		end
	end
end

addHook("PlayerHeight", CrouchHeight)
addHook("PlayerCanEnterSpinGaps", CrouchGap)

-- Damage Handler

addHook("ShouldDamage", function(pmo, inf, src, dmg, dmgtype)

	if G_IsSpecialStage(gamemap) then return end

	if pmo and pmo.valid then
		if pmo.skin == "speccy" then
		
			if pmo.player then
				if (pmo.player.pflags & PF_GODMODE) then return false end
			end
		
			if dmgtype == DMG_INSTAKILL or dmgtype == DMG_CRUSHED or dmgtype == DMG_DROWNED or dmgtype == DMG_DEATHPIT then return true end
		
			if pmo.player then
				local p = pmo.player
				
				if p.powers[pw_flashing] or p.powers[pw_invulnerability] or p.powers[pw_super] then
					return false
				elseif p.powers[pw_shield] ~= SH_NONE then
					return true
				end
				
				if inf and inf.valid then
					if src and src.valid then
						if inf == src then
							if (src.flags & MF_BOSS) then
								if adventureBossTable[src.type] ~= nil then
									p.speccy.hp = $ - adventureBossTable[src.type][2]
								else
									p.speccy.hp = $ - 25
								end
								
								P_DoPlayerPain(p, src, inf)
								p.powers[pw_flashing] = 2*TICRATE
							elseif (src.flags & MF_ENEMY) then
								p.speccy.hp = $ - P_RandomRange(5,10)
								P_DoPlayerPain(p, src, inf)
								p.powers[pw_flashing] = 2*TICRATE
							else
								if adventureInfTable[inf.type] ~= nil then
									p.speccy.hp = $ - adventureInfTable[inf.type]
								else
									p.speccy.hp = $ - P_RandomRange(10,15)
								end
								P_DoPlayerPain(p, src, inf)
								p.powers[pw_flashing] = 2*TICRATE
							end
						else
							if adventureInfTable[inf.type] ~= nil then
								p.speccy.hp = $ - adventureInfTable[inf.type]
							else
								p.speccy.hp = $ - P_RandomRange(10,15)
							end
							P_DoPlayerPain(p, src, inf)
							p.powers[pw_flashing] = 2*TICRATE
						end
					else
						if adventureInfTable[inf.type] ~= nil then
							p.speccy.hp = $ - adventureInfTable[inf.type]
						else
							p.speccy.hp = $ - P_RandomRange(10,15)
						end
						P_DoPlayerPain(p, src, inf)
						p.powers[pw_flashing] = 2*TICRATE
					end
					
					if p.speccy.hp <= 0 then
						p.speccy.hp = 0
						P_DamageMobj(pmo, inf, src, dmg, DMG_INSTAKILL)
					end
					
					return false
					
				end
				
				if dmgtype == DMG_SPIKE then
					p.speccy.hp = $ - 25
					P_DoPlayerPain(p, src, inf)
					p.powers[pw_flashing] = 3*TICRATE
				elseif dmgtype == DMG_FIRE then
					p.speccy.hp = $ - P_RandomRange(1, 2)
					p.powers[pw_flashing] = P_RandomRange(1, 2)
				elseif dmgtype == DMG_ELECTRIC then
					p.speccy.hp = $ - P_RandomRange(5, 10)
					p.powers[pw_flashing] = P_RandomRange(5, 10)
					if P_RandomRange(1, 2) == 2 then
						P_InstaThrust(pmo, p.drawangle, 0)
					end
				elseif dmgtype == DMG_WATER then
					p.speccy.hp = $ - P_RandomRange(1, 2)
					p.powers[pw_flashing] = P_RandomRange(2, 5)
				elseif dmgtype == DMG_NUKE then
					p.speccy.hp = $ - 50
					p.powers[pw_flashing] = 3*TICRATE
				end
				
				if p.speccy.hp <= 0 then
					p.speccy.hp = 0
					P_DamageMobj(pmo, inf, src, dmg, DMG_INSTAKILL)
				end
				
				return false
				
			end
		end
	end
end)

-- Enemy Handler

addHook("ShouldDamage", function(mo, inf, src, dmg, dmgtype)
	if src and src.valid then
		if src.player and src.skin == "speccy" then
			if mo and mo.valid then
				if (mo.flags & MF_ENEMY) or (mo.flags & MF_BOSS) then
				
					if dmgtype == DMG_NUKE then
						return true
					end
				
					if (mo.flags & MF_BOSS) and (mo.flags2 & MF2_FRET) then
						return false
					end
				
					if (mo.flags & MF_BOSS) then
						P_InstaThrust(src, src.angle, -4*FRACUNIT)
					end
	
				end
			end
		end
	end
end)

-- EXP Handler

addHook("MobjDeath", function(mo, inf, pmo)
	if pmo and pmo.valid then
		if pmo.player and pmo.player.speccy and pmo.skin == "speccy" then
			if (mo.flags & MF_BOSS) then
				if adventureBossTable[mo.type] ~= nil then
					pmo.player.speccy.exp = $ + (adventureBossTable[mo.type][3]+pmo.player.speccy.chaobonus)*pmo.player.speccy.multiplier/FRACUNIT
				else
					pmo.player.speccy.exp = $ + (25+pmo.player.speccy.chaobonus)*pmo.player.speccy.multiplier/FRACUNIT
				end
			elseif (mo.flags & MF_ENEMY) then
				pmo.player.speccy.exp = $ + (P_RandomRange(9,12)+pmo.player.speccy.chaobonus)*pmo.player.speccy.multiplier/FRACUNIT
				local ring = P_SpawnMobj(mo.x, mo.y, mo.z, MT_FLINGRING)
				ring.target = pmo
				ring.fuse = 12*FRACUNIT
				ring.reactiontime = 8*FRACUNIT
				P_SetObjectMomZ(ring, P_RandomRange(3,6)*FRACUNIT, false)
				P_InstaThrust(ring, FixedAngle(P_RandomRange(0, 359)*FRACUNIT), P_RandomRange(1,2)*FRACUNIT)
				if pmo.player.powers[pw_super] then
					pmo.player.speccy.supertime = $ + 17
				elseif emeralds == 127 then
					pmo.player.speccy.supertime = $ + 35
				end
			end
		end
	end
end)

addHook("MobjDeath", function(mo, inf, pmo)
	if pmo and pmo.valid then
		if pmo.player and pmo.player.speccy and pmo.skin == "speccy" then
			if adventureEXPTable[mo.type] ~= nil then
				pmo.player.speccy.exp = $ + (adventureEXPTable[mo.type]+pmo.player.speccy.chaobonus)*pmo.player.speccy.multiplier/FRACUNIT
			elseif (mo.flags & MF_MONITOR) then
				pmo.player.speccy.exp = $ + (10+pmo.player.speccy.chaobonus)*pmo.player.speccy.multiplier/FRACUNIT
			end
			
			if adventureHealTable[mo.type] ~= nil then
				for i=1,adventureHealTable[mo.type] do
					if pmo.player.speccy.hp < pmo.player.speccy.maxhp then
						pmo.player.speccy.hp = $ + 1
					end
				end
			end
			
			if mo.type == MT_RING or mo.type == MT_FLINGRING then
				if pmo.player.powers[pw_super] then
					pmo.player.speccy.rings = $ + 2
				else
					pmo.player.speccy.rings = $ + 1
				end
			end
			
			if mo.type == MT_RING_BOX then
				pmo.player.speccy.rings = $ + 10
			end
			
		end
	end
end)

-- HUD stuff at the very bottom.
-- Seeing as people are going to be reading this maybe, I'll post on how to make a HUD.

-- In order to make a HUD, start with checking for the below:

if not speccyCustomHud then
  rawset(_G, "speccyCustomHud", {})
end

-- Starting with the actual HUD here.
-- You'll be wanting to read a lot of Speccy's stats here so I made a list for you!

    -- p.speccy    - This is your main array, always check for this after making sure the player exists.
    -- p.speccy.hp - Your health.
    -- p.speccy.maxhp - Your maximum health.
    -- p.speccy.level - Your level.
    -- p.speccy.exp   - Your current EXP count. 
    -- p.speccy.expreq   - EXP needed to reach next level. p.exqreq - p.exp to get EXP left.
    -- p.speccy.totalexp - Total EXP gained throughout the play session. It only updates when you level up. 
    -- p.speccy.supertime - How many tics you have left before you transform out of your Super form.
	-- So for a Total EXP counter do p.speccy.exp + p.speccy.totalexp

-- HUD function here.

--speccyCustomHud[#speccyCustomHud+1] = function(v, p)

    -- HUD Code here.
    
--end

-- What is MGR!? FIRST THE MUSIC, NOW THE HUD!?

speccyCustomHud[#speccyCustomHud+1] = function(v, p)

	-- RAIDEN? JACK? NAH MORE LIKE SPECCY!

	if p.powers[pw_super] then
		v.drawString(24, 17, "SPECCY", nil, "thin")
		v.drawString(24+v.stringWidth("SPECCY", nil, "thin")+2, 18, "- \x85SUPER\x80: "..tostring(p.speccy.supertime/TICRATE), nil, "small")
	elseif emeralds == 127 then
		v.drawString(24, 17, "SPECCY", nil, "thin")
		v.drawString(24+v.stringWidth("SPECCY", nil, "thin")+2, 18, "- \x86SUPER\x80: "..tostring(p.speccy.supertime/TICRATE), nil, "small")
	else
		v.drawString(24, 17, "SPECCY", nil, "thin")
	end
	
	-- Going to shove Rings here real quick-
	
	v.drawString(24, 200-17, "\x82o RINGS\x80: "+p.speccy.rings, nil, "thin")
	
	-- HP Bar & Percentage
	
	local percentageincrease = 0
	
	if p.speccy.level >= 100 then
		percentageincrease = p.speccy.level - 100
	end
	
	if not p.powers[pw_super] then
		if p.speccy.hp > p.speccy.maxhp and p.speccy.shades then
			v.drawFill(24, 26, 108, 1, 59)
			v.drawFill(24, 27, 108, 1, 55)
			v.drawFill(24, 28, 108, 1, 57)
			v.drawString(24+108, 16, tostring(((100+percentageincrease)*p.speccy.hp/p.speccy.maxhp*(100+percentageincrease))/(100+percentageincrease)).."%", V_REDMAP, "right")
			v.drawFill(132, 26, (108*p.speccy.hp/p.speccy.maxhp*108)/(206+54*4), 1, 39)
			v.drawFill(132, 27, (108*p.speccy.hp/p.speccy.maxhp*108)/(206+54*4), 1, 35)
			v.drawFill(132, 28, (108*p.speccy.hp/p.speccy.maxhp*108)/(206+54*4), 1, 37)
			v.drawFill(24, 26, 108, 1, 55)
			v.drawFill(24, 27, 108, 1, 51)
			v.drawFill(24, 28, 108, 1, 53)
		else
			v.drawFill(24, 26, 108, 1, 59)
			v.drawFill(24, 27, 108, 1, 55)
			v.drawFill(24, 28, 108, 1, 57)
			v.drawString(24+108, 16, tostring(((100+percentageincrease)*p.speccy.hp/p.speccy.maxhp*(100+percentageincrease))/(100+percentageincrease)).."%", V_ORANGEMAP, "right")
			v.drawFill(24, 26, (108*p.speccy.hp/p.speccy.maxhp*108)/108, 1, 55)
			v.drawFill(24, 27, (108*p.speccy.hp/p.speccy.maxhp*108)/108, 1, 51)
			v.drawFill(24, 28, (108*p.speccy.hp/p.speccy.maxhp*108)/108, 1, 53)
		end
	else
		v.drawFill(24, 26, 108, 1, skincolors[p.mo.color].ramp[15])
		v.drawFill(24, 27, 108, 1, skincolors[p.mo.color].ramp[7])
		v.drawFill(24, 28, 108, 1, skincolors[p.mo.color].ramp[11])
		v.drawString(24+108, 16, tostring(((100+percentageincrease)*p.speccy.hp/p.speccy.maxhp*(100+percentageincrease))/(100+percentageincrease)).."%", skincolors[p.mo.color].chatcolor, "right")
		v.drawFill(24, 26, (108*p.speccy.hp/p.speccy.maxhp*108)/108, 1, skincolors[p.mo.color].ramp[7])
		v.drawFill(24, 27, (108*p.speccy.hp/p.speccy.maxhp*108)/108, 1, skincolors[p.mo.color].ramp[0])
		v.drawFill(24, 28, (108*p.speccy.hp/p.speccy.maxhp*108)/108, 1, skincolors[p.mo.color].ramp[3])
	end
	
	-- EXP Bar... replaces your FC I guess.
	
	v.drawFill(24, 30, 96, 1, 139)
	v.drawFill(24, 31, 96, 1, 135)
	v.drawFill(24, 32, 96, 1, 137)
	v.drawFill(24, 33, 96, 1, 135)
	v.drawFill(24, 34, 96, 1, 137)
	
	if p.speccy.level >= 200 and p.speccy.exp >= p.speccy.expreq then
		v.drawFill(24, 30, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 39)
		v.drawFill(24, 31, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 35)
		v.drawFill(24, 32, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 37)
		v.drawFill(24, 33, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 35)
		v.drawFill(24, 34, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 37)
	else
		if p.speccy.exp >= p.speccy.expreq then
			v.drawFill(24, 30, 96, 1, 135)
			v.drawFill(24, 31, 96, 1, 131)
			v.drawFill(24, 32, 96, 1, 133)
			v.drawFill(24, 33, 96, 1, 131)
			v.drawFill(24, 34, 96, 1, 133)
		else
			v.drawFill(24, 30, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 135)
			v.drawFill(24, 31, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 131)
			v.drawFill(24, 32, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 133)
			v.drawFill(24, 33, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 131)
			v.drawFill(24, 34, (96*p.speccy.exp/p.speccy.expreq*96)/96, 1, 133)
		end
	end
	
	-- Lets put EXP values under it too.

	if p.speccy.level >= 200 and p.speccy.exp >= p.speccy.expreq then
		v.drawString(24, 36, ">EXP: "..tostring(p.speccy.exp).."/"..tostring(p.speccy.expreq), V_REDMAP, "thin")
	else
		v.drawString(24, 36, ">EXP: "..tostring(p.speccy.exp).."/"..tostring(p.speccy.expreq), V_SKYMAP, "thin")
	end
	
	-- And our Level under that-

	v.drawString(24, 44, ">LV: "..tostring(p.speccy.level), V_SKYMAP, "thin")
	
	-- And our lives under that...
	
	v.drawFill(24, 52, 8, 8, 53)
	v.drawString(24, 51, "+  ")
	v.drawString(34, 53, p.lives, nil, "thin")

	-- What about Bosses? Eh.. fine.

	if (not (p.speccy.boss and p.speccy.boss.valid)) or p.speccy.boss.health <= 0 then
		for mobj in mobjs.iterate() do
			if (mobj.flags & MF_BOSS) and R_PointToDist2(p.mo.x, p.mo.y, mobj.x, mobj.y) < 2048*FRACUNIT and mobj.health > 0 then
				p.speccy.boss = mobj
			end
		end
	else
	
		if adventureBossTable[p.speccy.boss.type] ~= nil then
			v.drawString(320-132, 200-36, adventureBossTable[p.speccy.boss.type][1], nil, "thin")
		else
			v.drawString(320-132, 200-36, "BOSS", nil, "thin")
		end
		
		if (p.speccy.boss.type == MT_METROIDBOSS) then
			p.speccy.boss = p.speccy.boss.hitbox
		end
		
		if (p.speccy.boss.type == MT_CYBRAKDEMON) or (p.speccy.boss.type == MT_EGGANIMUS) then
			if p.speccy.boss.type == MT_EGGANIMUS then
				v.drawString(320-24, 200-37, tostring(100+(100*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*100)/100).."%", V_ORANGEMAP, "right")
			else
				if p.speccy.boss.superbrak then
					v.drawString(320-24, 200-37, tostring((100*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*100)/46).."%", V_REDMAP, "right")
				else
					v.drawString(320-24, 200-37, tostring((100*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*100)/50).."%", V_ORANGEMAP, "right")
				end
			end
		else
			v.drawString(320-24, 200-37, tostring((100*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*100)/100).."%", V_ORANGEMAP, "right")
		end
		
		v.drawFill(320-132, 200-28, 108, 1, 133) 
		if p.speccy.boss.superbrak then
			v.drawFill(320-132, 200-25, 108, 1, 43)
			v.drawFill(320-132, 200-24, 108, 1, 39)
			v.drawFill(320-132, 200-23, 108, 1, 41)
		else
			v.drawFill(320-132, 200-25, 108, 1, 59)
			v.drawFill(320-132, 200-24, 108, 1, 55)
			v.drawFill(320-132, 200-23, 108, 1, 57)
		end
		if (p.speccy.boss.type == MT_EGGANIMUS_EX) then
			v.drawFill(320-132, 200-25, (54*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*54)/54, 1, 55)
			v.drawFill(320-132, 200-24, (54*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*54)/54, 1, 51)
			v.drawFill(320-132, 200-23, (54*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*54)/54, 1, 53)
		elseif (p.speccy.boss.type == MT_EGGANIMUS) then
			v.drawFill(320-132, 200-25, 54, 1, 55)
			v.drawFill(320-132, 200-24, 54, 1, 51)
			v.drawFill(320-132, 200-23, 54, 1, 53)
			v.drawFill(320-132+54, 200-25, (54*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*54)/54, 1, 55)
			v.drawFill(320-132+54, 200-24, (54*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*54)/54, 1, 51)
			v.drawFill(320-132+54, 200-23, (54*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*54)/54, 1, 53)
		else
			if p.speccy.boss.superbrak then
				v.drawFill(320-132, 200-25, (54/2*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*108)/108-18, 1, 39)
				v.drawFill(320-132, 200-24, (54/2*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*108)/108-18, 1, 35)
				v.drawFill(320-132, 200-23, (54/2*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*108)/108-18, 1, 37)
			else
				v.drawFill(320-132, 200-25, (108*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*108)/108, 1, 55)
				v.drawFill(320-132, 200-24, (108*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*108)/108, 1, 51)
				v.drawFill(320-132, 200-23, (108*p.speccy.boss.health/mobjinfo[p.speccy.boss.type].spawnhealth*108)/108, 1, 53)
			end
		end
	
	end
	
	-- Tips n' Hints... not implemented yet.


	-- Chao!
	
	if (p.speccy.chao and p.speccy.chao.valid) then
		
		v.drawString(24, 62, "SPECCY CHAO", nil, "small")
		v.drawString(24, 70, ">LV: "+p.speccy.chaolevel, V_SKYMAP, "small")
		v.drawString(24, 66, ">EXP: "+p.speccy.chaoexp+"/"+p.speccy.chaoexpreq, V_SKYMAP, "small")
		
	end

end

-- ZELDA II-esque HUD

local localleveltime = 0

speccyCustomHud[#speccyCustomHud+1] = function(v, p)

	if (leveltime < 1) or (p.playerstate == PST_REBORN) then
		localleveltime = 0
	end

	if localleveltime < 2*TICRATE then
		v.drawFill(0, 0, 320, 200, 31)
		local icon = v.getSprite2Patch(p.mo.skin, SPR2_LIFE, p.powers[pw_super], 0, 0, 0)
		v.draw(146, 106, icon, nil, v.getColormap(p.mo.skin, p.mo.color))
		v.draw(156, 102, v.cachePatch("STLIVEX"), nil)
		v.drawString(164, 100, tostring(p.lives), nil)
		localleveltime = $ + 1
	end
	
	-- Black Bar for that nice feel.
	
	v.drawFill(0, 0, 320, 24, 31)

	-- Stats first, put where the Magic and Levels would be in Zelda II.

	local statsx = 52
	local statsy = 2
	
	v.drawString(statsx, statsy, "Level "+p.speccy.level, nil, "thin-center")                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  

	-- HP Bar.
	
	local hpbarx = 102
	local hpbary = 6
	
	v.drawFill(hpbarx, hpbary, 12, 12, 150)
	v.drawString(hpbarx+6, hpbary+2, "L", nil, "center")
	v.drawFill(hpbarx+12, hpbary, 98, 12, 0)
	v.drawFill(hpbarx+12, hpbary+2, 96, 8, 31)
	v.drawFill(hpbarx+12, hpbary+2, (96*p.speccy.hp/p.speccy.maxhp*96)/96, 8, 35)
	for i=1,8 do
		v.drawFill(hpbarx+12+(i-1)*12, hpbary, 2, 12, 0)
	end
	
	-- NEXT text for EXP reasons.
	
	local paddedexp = tostring(p.speccy.exp)
	local paddedexpreq = tostring(p.speccy.expreq)
	 
	for i=1, 5 do
		if string.len(paddedexp) < i then
			paddedexp = "0" .. paddedexp
		end
		if string.len(paddedexpreq) < i then
			paddedexpreq = "0" .. paddedexpreq
		end
	end
	 
	local expx = 320 - 52
	local expy = 2
	
	v.drawString(expx, expy, "      NEXT", nil, "center")   
	v.drawString(expx, expy+10, paddedexp .. "/" .. paddedexpreq, nil, "center")

end

-- PSO HUD, completely based off of the PSO ver 2 HUD from the Dreamcast release.

speccyCustomHud[#speccyCustomHud+1] = function(v, p)
	
	-- The main HUD overlay, we'll put stuff on top of it.
	
	v.draw(12, 16, v.cachePatch("PSOSPEC"), nil)
	
	-- An odd place for it, but lets put our lives where your MAG charges would be.
	
	v.drawString(39, 24, p.lives, nil, "thin")
	
	-- Our health display, contains number value, and bar.
	
	v.drawString(57, 20, "HP "..tostring(p.speccy.hp).."/"..tostring(p.speccy.maxhp), nil, "thin")
	v.drawFill(58, 27, 56, 4, 14)
	v.drawFill(58, 27, (56*p.speccy.hp/p.speccy.maxhp*56)/56, 4, 114)
	v.drawFill(59, 28, (54*p.speccy.hp/p.speccy.maxhp*54)/54, 2, 112)
	
	-- Lets replace the TP with EXP hmm?
	
	v.drawString(51, 34, "EXP "..tostring(p.speccy.exp).."/"..tostring(p.speccy.expreq), nil, "thin")
	v.drawFill(52, 41, 56, 4, 14)
	v.drawFill(52, 41, (56*p.speccy.exp/p.speccy.expreq*56)/56, 4, 135)
	v.drawFill(53, 42, (54*p.speccy.exp/p.speccy.expreq*54)/54, 2, 134)
	
	-- The player's level.
	
	v.drawString(22, 48, "Lv", nil, "thin")
	v.drawString(51, 48, p.speccy.level, nil, "thin-right")
	
	-- The player's name in the bottom right.
	
	v.drawString(56, 50, p.name, V_YELLOWMAP, "thin")
	
end

local speccy_hud = 1

COM_AddCommand("speccy_hud", function(p, arg)
	if tonumber(arg) ~= nil then
		speccy_hud = tonumber(arg)
	end
end, COM_LOCAL)

hud.add(function(v,p)
	if p.mo.skin ~= "speccy" or (not p.speccy) then
		return
	end
	
	if G_IsSpecialStage(gamemap) then return end
	
	hud.disable("score")
	hud.disable("time")
	hud.disable("rings")
	hud.disable("lives")

	speccyCustomHud[speccy_hud](v, p)
end, "game")

addHook("PlayerSpawn", function(p)
	hud.enable("score")
	hud.enable("time")
	hud.enable("rings")
	hud.enable("lives")
end)

hud.add(function(v,p)
	if G_IsSpecialStage(gamemap) then return end

	if skinchanged then
		hud.enable("score")
		hud.enable("time")
		hud.enable("rings")
		hud.enable("lives")
		skinchanged = false
	end
end, "game")