-- Speccy Chao's script.

freeslot("SPR_SPCS", "SPR_SPCT", "SPR_SPCM", "S_SPECCYCHAO_STAND", "S_SPECCYCHAO_THINK", "S_SPECCYCHAO_MOVE", "MT_SPECCYCHAO")

states[S_SPECCYCHAO_STAND] = {

	sprite = SPR_SPCS,
	frame = A,
	tics = -1,
	nextstate = S_NULL

}

states[S_SPECCYCHAO_THINK] = {

	sprite = SPR_SPCT,
	frame = A,
	tics = -1,
	nextstate = S_NULL

}

states[S_SPECCYCHAO_MOVE] = {

	sprite = SPR_SPCM,
	frame = A,
	tics = -1,
	nextstate = S_NULL

}

mobjinfo[MT_SPECCYCHAO] = {
	doomednum = 4000,
	spawnstate = S_SPECCYCHAO_STAND,
	spawnhealth = 1,
	radius = 64*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOCLIPHEIGHT
}

rawset(_G, "speccyChaoEXPTable", {
	[MT_RING] = 1,
	[MT_FLINGRING] = 1,
	[MT_BLUESPHERE] = 3,
	[MT_RING_BOX] = 5,
	[MT_1UP_BOX] = 10,
})

-- A_FindTarget ported to Lua by Jon. (Thank you.)

local function A_FindTargetLua(mo, target, farthest)

    local targetedmobj = nil
    local dist1,dist2 = 0,0
    
    if mo.player
        CONS_Printf(mo.player, "A_FindTarget called from object type " .. mo.type .. ", var1: " .. target .. " var2: " .. tostring(farthest))
    end

    for mo2 in mobjs.iterate() do

        if mo2.type == target
            if mo2.player and ((not mo2.player.valid) or mo2.player.pflags & PF_INVIS)
                continue
            end
            if mo2.health <= 0
                continue
            end
            if targetedmobj == nil
				if abs(mo2.z+mo2.momz+mo2.height - mo.z) > 128*FRACUNIT or R_PointToDist2(mo.x, mo.y, mo2.x, mo2.y) > mo.owner.player.speccy.chaorange*FRACUNIT then
					continue
				end
                targetedmobj = mo2
                dist2 = R_PointToDist2(mo.x, mo.y, mo2.x, mo2.y)
            else
                dist1 = R_PointToDist2(mo.x, mo.y, mo2.x, mo2.y)

                if ((not farthest) and dist1 < dist2) or (farthest and dist1 > dist2)
					if abs(mo2.z+mo2.momz+mo2.height - mo.z) > 128*FRACUNIT or R_PointToDist2(mo.x, mo.y, mo2.x, mo2.y) > mo.owner.player.speccy.chaorange*FRACUNIT then
						continue
					end
                    targetedmobj = mo2
                    dist2 = dist1
                end
            end
        end
    end

    if not targetedmobj
        if mo.player then CONS_Printf(mo.player, "A_FindTarget: Unable to find the specified object to target.\n") end
        return
    end
    
    if mo.player then CONS_Printf(mo.player, "A_FindTarget: Found a target.\n") end

    mo.target = targetedmobj
end

addHook("PlayerThink", function(p)
	if p.speccy and p.mo.skin == "speccy" then
		if not (p.speccy.chao and p.speccy.chao.valid) then
			if p.speccy.chaobought then
				spawnSpeccyChao(p)
			end
		end
	end
end)

addHook("MobjThinker", function(chao)
	if chao and chao.valid then
	
		chao.scale = FRACUNIT/4
		chao.color = SKINCOLOR_CARBON
	
		if (chao.owner and chao.owner.valid) and chao.owner.player then
		
			if chao.owner.player.speccy.chaoexp >= chao.owner.player.speccy.chaoexpreq then
				S_StartSound(chao, sfx_cdfm49, chao.owner.player)
				chao.owner.player.speccy.chaoexp = $ - chao.owner.player.speccy.chaoexpreq
				chao.owner.player.speccy.chaolevel = $ + 1
				chao.owner.player.speccy.chaoexpreq = $ + (($^2)/chao.owner.player.speccy.chaolevel)/($/2 + $/4)
				chao.owner.player.speccy.chaobonus = $ + (($^2)/chao.owner.player.speccy.chaolevel)/($/2 + $/4)
				if chao.owner.player.speccy.chaolevel <= 15 then
					chao.owner.player.speccy.chaorange = $+16
				end
			end
			
			if not chao.chasing then
				if G_IsSpecialStage(gamemap) then
					P_InstaThrust(chao, R_PointToAngle2(chao.x, chao.y, chao.owner.x, chao.owner.y), (R_PointToDist2(chao.x, chao.y, chao.owner.x, chao.owner.y)-16*FRACUNIT)/8)
					P_SetObjectMomZ(chao, (chao.owner.z+chao.owner.momz+chao.owner.height+4*FRACUNIT - chao.z)/4, false)
					chao.angle = R_PointToAngle2(chao.x, chao.y, chao.owner.x, chao.owner.y)
				else
					P_InstaThrust(chao, R_PointToAngle2(chao.x, chao.y, chao.owner.x, chao.owner.y), (R_PointToDist2(chao.x, chao.y, chao.owner.x, chao.owner.y)-16*FRACUNIT)/17)
					P_SetObjectMomZ(chao, (chao.owner.z+chao.owner.momz+chao.owner.height+4*FRACUNIT - chao.z)/8, false)
					chao.angle = R_PointToAngle2(chao.x, chao.y, chao.owner.x, chao.owner.y)
				end
			
				if (chao.owner.player.cmd.buttons & BT_CUSTOM3) or R_PointToDist2(chao.x, chao.y, chao.owner.x, chao.owner.y) >= (chao.owner.player.speccy.chaorange*3)*FRACUNIT or abs(chao.owner.z+chao.owner.momz+chao.owner.height+4*FRACUNIT - chao.z) > 256*FRACUNIT then
					P_TeleportMove(chao, chao.owner.x, chao.owner.y, chao.owner.z)
				end
			
				if chao.cooldown then
					chao.cooldown = $ - 1
					return
				end
			
				for mobj in mobjs.iterate() do
					if chao.owner.player.speccy.chaolevel < 6 then
						if (mobj.type == MT_RING or mobj.type == MT_BLUESPHERE or mobj.type == MT_FLINGRING) and R_PointToDist2(chao.x, chao.y, mobj.x, mobj.y) <= chao.owner.player.speccy.chaorange*FRACUNIT and not mobj.canttarget then
							A_FindTargetLua(chao, mobj.type, 0)
							chao.chasing = true
						end
					elseif chao.owner.player.speccy.chaolevel < 13 then
						if ((mobj.type == MT_RING or mobj.type == MT_BLUESPHERE or mobj.type == MT_FLINGRING) or (mobj.flags & MF_MONITOR)) and R_PointToDist2(chao.x, chao.y, mobj.x, mobj.y) <= chao.owner.player.speccy.chaorange*FRACUNIT and not mobj.canttarget then
							A_FindTargetLua(chao, mobj.type, 0)
							chao.chasing = true
						end
					elseif chao.owner.player.speccy.chaolevel < 20 then
						if ((mobj.type == MT_RING or mobj.type == MT_BLUESPHERE or mobj.type == MT_FLINGRING) or (mobj.flags & MF_MONITOR) or (mobj.flags & MF_ENEMY)) and R_PointToDist2(chao.x, chao.y, mobj.x, mobj.y) <= chao.owner.player.speccy.chaorange*FRACUNIT and not mobj.canttarget then
							A_FindTargetLua(chao, mobj.type, 0)
							chao.chasing = true
						end
					else
						if ((mobj.type == MT_RING or mobj.type == MT_BLUESPHERE or mobj.type == MT_FLINGRING) or (mobj.flags & MF_MONITOR) or (mobj.flags & MF_ENEMY) or (mobj.flags & MF_BOSS)) and R_PointToDist2(chao.x, chao.y, mobj.x, mobj.y) <= chao.owner.player.speccy.chaorange*FRACUNIT and not mobj.canttarget then
							A_FindTargetLua(chao, mobj.type, 0)
							chao.chasing = true
						end
					end
				end
			elseif chao.target and chao.target.valid then
				if (chao.owner.player.cmd.buttons & BT_CUSTOM3) then
					P_TeleportMove(chao, chao.owner.x, chao.owner.y, chao.owner.z)
					chao.chasing = false
					chao.target = nil
				end
				if G_IsSpecialStage(gamemap) then
					P_InstaThrust(chao, R_PointToAngle2(chao.x, chao.y, chao.target.x, chao.target.y), R_PointToDist2(chao.x, chao.y, chao.target.x, chao.target.y)/8)
					P_SetObjectMomZ(chao, (chao.target.z+chao.target.momz+(chao.target.height/2) - chao.z)/4, false)
					chao.angle = R_PointToAngle2(chao.x, chao.y, chao.target.x, chao.target.y)
				else
					P_InstaThrust(chao, R_PointToAngle2(chao.x, chao.y, chao.target.x, chao.target.y), R_PointToDist2(chao.x, chao.y, chao.target.x, chao.target.y)/16)
					P_SetObjectMomZ(chao, (chao.target.z+chao.target.momz+(chao.target.height/2) - chao.z)/8, false)
					chao.angle = R_PointToAngle2(chao.x, chao.y, chao.target.x, chao.target.y)
				end
			else
				chao.chasing = false
			end
			
			if abs(chao.momx+chao.momy) > 1*FRACUNIT then
				chao.state = S_SPECCYCHAO_MOVE
			elseif chao.owner.state == S_PLAY_WAIT then
				chao.state = S_SPECCYCHAO_THINK
			elseif chao.owner.state == S_PLAY_STND then
				chao.state = S_SPECCYCHAO_STAND
			end
		else
			chao.momz = 0
			if not chao.statechosen then
				if P_RandomRange(1, 2) == 1 then
					chao.state = S_SPECCYCHAO_STAND
				else
					chao.state = S_SPECCYCHAO_THINK
				end
				
				chao.statechosen = true
			end
		end
	end
end, MT_SPECCYCHAO)

addHook("MobjMoveCollide", function(chao, target)
	if target == chao.target then
	
		if not (chao.z >= chao.target.z and chao.z <= chao.target.z + chao.target.height) then
			return
		end
	
		if (chao.target.type == MT_RING or chao.target.type == MT_BLUESPHERE or chao.target.type == MT_FLINGRING) then
			if chao.target.type == MT_BLUESPHERE then
				chao.owner.player.spheres = $ + 1
			end
			if G_IsSpecialStage(gamemap) then
				chao.owner.player.linkcount = $ + 1
				chao.owner.player.linktimer = 2*TICRATE
				if chao.owner.player.linkcount < 9 then
					P_AddPlayerScore(chao.owner.player, 10+(10*chao.owner.player.linkcount))
				else
					P_AddPlayerScore(chao.owner.player, 100)
				end
			end
			P_KillMobj(target, chao, chao.owner)
		elseif chao.target.health > 0 then
			P_DamageMobj(target, chao, chao.owner)
		end
		S_StartSound(chao.owner, target.info.painsound, chao.owner.player)
		if speccyChaoEXPTable[target.type] then
			chao.owner.player.speccy.chaoexp = $+speccyChaoEXPTable[target.type]
		else
			if chao.target.flags & MF_MONITOR then
				if speccyChaoEXPTable[target.type] then
					chao.owner.player.speccy.chaoexp = $+speccyChaoEXPTable[target.type]
				else
					chao.owner.player.speccy.chaoexp = $+5
				end
			else
				chao.owner.player.speccy.chaoexp = $+7
			end
		end
		if (chao.target.flags & MF_BOSS) then
			chao.cooldown = 3*TICRATE
		end
		
		if chao.target.flags & MF_MONITOR then
			chao.target.canttarget = true
		end
		
		chao.target = nil
		chao.chasing = false
	end
end, MT_SPECCYCHAO)

addHook("MobjDamage", function(monitor, inf, src)
	if monitor.flags & MF_MONITOR then
		monitor.canttarget = true
	end
end)

rawset(_G, "spawnSpeccyChao", function(p)
	if p.mo and p.mo.valid then
		if p.speccy and p.mo.skin == "speccy" then
			if not (p.speccy.chao and p.speccy.chao.valid) then
				p.speccy.chao = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPECCYCHAO)
				p.speccy.chao.owner = p.mo
				if not p.speccy.chaobonus then
					p.speccy.chaoexp = 0
					p.speccy.chaoexpreq = 5
					p.speccy.chaolevel = 1
					p.speccy.chaobonus = 5
					p.speccy.chaorange = 128
				end
			end
		end
	end
end)

adventureShopTable["speccychao"] = {"Speccy Chao", "A cute little chao that looks just\nlike you. It'll pick up objects for you,\nand boost your Base EXP gain.\nPress CUSTOM 3 to recall your Chao if\nit's stuck.", 1250}
