-- Laptop system.
-- Likely going to be a pain to make. Yay.
-- Will release with v1.1 in a usable, but minimal state.

if srb2p then return end

rawset(_G, "setupLaptop", function(p)
	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" and p.speccy then
			p.speccy.laptop = {
				windows = {},
				desktop = {
					desktopdefs = {
						background = "SPECBG01",
						backgroundstyle = "full",
					},
				},
				mousex = 160,
				mousey = 100,
				mousedown = 0,
				mousespeed = 2,
				controlstyle = 1,
				cursor = "^",
			}
		else
			error("cannot run setupLaptop if you're not Speccy!", 2)
		end
	else
		error("cannot run setupLaptop if you don't exist!", 2)
	end
end)

rawset(_G, "shopDraw", function(v, p, window)
	local inwindowx = window.x+window.windowdefs.bordersize/2
	local inwindowy = window.y+16+window.windowdefs.bordersize/2+1
	v.drawString(inwindowx+inwindowx/2, inwindowy+2, "  - Shop Listings -", nil, "thin")
	
	-- Chao Button
	
	if window.chaobutton then
		v.drawScaled((window.chaobutton.x+6)*FRACUNIT, (window.chaobutton.y+20)*FRACUNIT, FRACUNIT/4, v.getSpritePatch(window.chaobutton.patch, 0, 8), nil, v.getColormap(nil, SKINCOLOR_CARBON))
		v.drawString(window.chaobutton.x+16, window.chaobutton.y+2, window.chaobutton.name, nil, "small")
		v.drawString(window.chaobutton.x+16, window.chaobutton.y+9, window.chaobutton.desc, nil, "small")
		v.drawString(inwindowx+window.windowdefs.width-38, window.chaobutton.y+2, "COST: "+window.chaobutton.cost, nil, "small")
	end
	
	v.drawString(inwindowx+2, inwindowy+2, "RINGS: "+p.speccy.rings, nil, "small")
	return
end)

rawset(_G, "shopAction", function(p, window)
	if checkHitbox(p.speccy.laptop, window.chaobutton, nil, nil) and p.speccy.laptop.mousedown == 1 then
		if p.speccy.rings >= window.chaobutton.cost then
			p.speccy.chaobought = 1
			window.chaobutton.bought = true
			p.speccy.rings = $ - window.chaobutton.cost
			spawnSpeccyChao(p)
			S_StartSound(p.mo, sfx_addfil, p)
			window.chaobutton = nil
		else
			S_StartSound(p.mo, sfx_notadd, p)
		end
	end
end)

rawset(_G, "setupShopBuyButtons", function(p, window)

	local inwindowx = window.windowdefs.startx+window.windowdefs.bordersize/2
	local inwindowy = window.windowdefs.starty+16+window.windowdefs.bordersize/2+1

	window.chaobutton = {
		x = inwindowx+2,
		y = inwindowy+12,
		width = 236,
		length = 36,
		patch = SPR_SPCM,
		name = adventureShopTable["speccychao"][1],
		desc = adventureShopTable["speccychao"][2],
		cost = adventureShopTable["speccychao"][3],
		bought = false,
	}
	
end)

rawset(_G, "shopWindowSetup", function(p)
	p.speccy.laptop.windows[#p.speccy.laptop.windows + 1] = {
		windowdefs = {
			title = "SpecciShop",
			startx = 80,
			starty = 36,
			width = 160,
			length = 120,
			bordersize = 2,
			borderless = false,
			titlecolor = V_WHITEMAP,
			windowcolor = 17,
			bordercolor = 21,
			drawfunction = shopDraw,
			actionfunction = shopAction,
		},
		
		closebutton = {
			xmark = "X",
			color = 17,
			highlightcolor = 35,
			highlighted = false,
		}
	}
	
	setupShopBuyButtons(p, p.speccy.laptop.windows[1])
end)

rawset(_G, "shopButtonSetup", function(p)
	p.speccy.laptop.desktop[#p.speccy.laptop.desktop + 1] = {
		x = 4, 
		y = 4, 
		width = 32, 
		length = 32, 
		color = 0, 
		patch = "SHOPICON",
		name = "Shop", 
		flags = nil, 
		align = "thin-center",
		button = true,
		clickfunction = shopWindowSetup,
	}
end)

rawset(_G, "gcButtonSetup", function(p)
	p.speccy.laptop.desktop[#p.speccy.laptop.desktop + 1] = {
		x = 4, 
		y = 46, 
		width = 32, 
		length = 32, 
		color = skincolors[SKINCOLOR_PURPLE].ramp[8], 
		patch = "CUBEICON",
		name = "Nintendo\nGameCube", 
		flags = nil, 
		align = "small-center",
		button = true,
		clickfunction = gcWindowSetup,
	}
end)

rawset(_G, "gcWindowSetup", function(p)
	p.speccy.laptop.windows[#p.speccy.laptop.windows + 1] = {
		windowdefs = {
			title = "Nintendo GameCube",
			startx = 0,
			starty = 0,
			width = 320,
			length = 200,
			bordersize = 2,
			borderless = true,
			titlecolor = V_WHITEMAP,
			windowcolor = 31,
			bordercolor = 21,
			drawfunction = gcDraw,
			actionfunction = gcAction,
		},
		
		tics = 1,
		
	}
end)

rawset(_G, "gcDraw", function(v, p, window)
	v.drawFill(window.x, window.y, window.windowdefs.width, window.windowdefs.length, window.windowdefs.windowcolor)
	v.drawScaled((window.x+32)*FRACUNIT, (window.y+16)*FRACUNIT, FRACUNIT/2, v.cachePatch("GCUBE"+window.tics))
end)

rawset(_G, "gcAction", function(p, window)
	if window.tics >= 256 then
		p.speccy.laptop.windows = {}
		COM_BufInsertText(p, "tunes -default")
	else
		if S_MusicName() ~= "GACUBE" then
			S_ChangeMusic("GACUBE", false, p)
		end
		window.tics = $ + 1
	end
end)

rawset(_G, "settingsButtonSetup", function(p)
	p.speccy.laptop.desktop[#p.speccy.laptop.desktop + 1] = {
		x = 4, 
		y = 156, 
		width = 32, 
		length = 32, 
		color = skincolors[SKINCOLOR_PURPLE].ramp[8], 
		patch = "SETTINGS",
		name = " Settings", 
		flags = nil, 
		align = "thin-center",
		button = true,
		clickfunction = settingsWindowSetup,
	}
end)

rawset(_G, "settingsWindowSetup", function(p)
	p.speccy.laptop.windows[#p.speccy.laptop.windows + 1] = {
		windowdefs = {
			title = "Laptop Settings",
			startx = 80,
			starty = 36,
			width = 160,
			length = 120,
			bordersize = 2,
			borderless = false,
			titlecolor = V_WHITEMAP,
			windowcolor = 17,
			bordercolor = 21,
			drawfunction = settingsDraw,
			actionfunction = settingsAction,
		},
		
		closebutton = {
			xmark = "X",
			color = 17,
			highlightcolor = 35,
			highlighted = false,
		},
		
		style1button = {
			x = 92,
			y = 64,
			width = 24,
			length = 24,
			patch = "CTRLSTY1",
		},
		
		style2button = {
			x = 118,
			y = 64,
			width = 24,
			length = 24,
			patch = "CTRLSTY2",
		},
		
		leftbutton = {
			x = 100,
			y = 120,
			width = 8,
			length = 8,
			text = "<",
		},
		
		rightbutton = {
			x = 130,
			y = 120,
			width = 8,
			length = 8,
			text = ">",
		},
		
		savebutton = {
			x = 178,
			y = 64,
			width = 24,
			length = 24,
			patch = "SAVEICON",
		},
		
		resetbutton = {
			x = 204,
			y = 64,
			width = 24,
			length = 24,
			patch = "RESTICON",
		},
		
	}
end)

rawset(_G, "settingsDraw", function(v, p, window)
	local inwindowx = window.windowdefs.startx+window.windowdefs.bordersize/2
	local inwindowy = window.windowdefs.starty+16+window.windowdefs.bordersize/2+1

	v.drawString(inwindowx+1, inwindowy+1, "Control Options", nil, "thin")
	v.drawString(inwindowx+window.windowdefs.width-1, inwindowy+1, "Save Data        ", nil, "thin-right")
	v.drawString(117, 96, "Mouse Speed", nil, "thin-center")
	v.drawString(window.leftbutton.x, window.leftbutton.y, window.leftbutton.text, nil, "thin")
	v.drawString(window.rightbutton.x, window.rightbutton.y, window.rightbutton.text, nil, "thin")
	v.drawNum(121, 120-2, p.speccy.laptop.mousespeed)
	v.draw(window.style1button.x, window.style1button.y, v.cachePatch(window.style1button.patch))
	v.draw(window.style2button.x, window.style2button.y, v.cachePatch(window.style2button.patch))
	v.draw(window.savebutton.x, window.savebutton.y, v.cachePatch(window.savebutton.patch))
	v.draw(window.resetbutton.x, window.resetbutton.y, v.cachePatch(window.resetbutton.patch))
	if window.resetdisplay then
		v.drawString(inwindowx+1+window.windowdefs.width/2, inwindowy+1+window.windowdefs.length/2, "HOLD SPIN + CLICK TO RESET SAVE DATA", V_REDMAP, "thin-center")
	end
	
	return
end)

rawset(_G, "settingsAction", function(p, window)
	local inwindowx = window.windowdefs.startx+window.windowdefs.bordersize/2
	local inwindowy = window.windowdefs.starty+16+window.windowdefs.bordersize/2+1

	if checkHitbox(p.speccy.laptop, window.style1button, nil, window) and p.speccy.laptop.mousedown then
		p.speccy.laptop.controlstyle = 1
	elseif checkHitbox(p.speccy.laptop, window.style2button, nil, window) and p.speccy.laptop.mousedown then
		p.speccy.laptop.controlstyle = 2
	end
	
	if checkHitbox(p.speccy.laptop, window.leftbutton, nil, window) and p.speccy.laptop.mousedown == 1 then
		p.speccy.laptop.mousespeed = $ - 1
	elseif checkHitbox(p.speccy.laptop, window.rightbutton, nil, window) and p.speccy.laptop.mousedown == 1 then
		p.speccy.laptop.mousespeed = $ + 1
	end
	
	if checkHitbox(p.speccy.laptop, window.savebutton, nil, window) and p.speccy.laptop.mousedown == 1 then
		saveSpeccyData(p)
		S_StartSound(p.mo, sfx_addfil, p)
	elseif checkHitbox(p.speccy.laptop, window.resetbutton, nil, window) and p.speccy.laptop.mousedown == 1 then
		if p.cmd.buttons & BT_USE then
			resetSpeccyVars(p, true)
			S_StartSound(p.mo, sfx_notadd, p)
		else
			window.resetdisplay = 2*TICRATE
			S_StartSound(p.mo, sfx_alarm, p)
		end
	end
	
	if window.resetdisplay then
		window.resetdisplay = $ - 1
	end
	
	if p.speccy.laptop == nil then
		return
	end
	
	if p.speccy.laptop.mousespeed > 5 then
		p.speccy.laptop.mousespeed = 5
	elseif p.speccy.laptop.mousespeed < 1 then
		p.speccy.laptop.mousespeed = 1
	end

	return
end)

rawset(_G, "checkHitbox", function(laptop, button, closewindow, window)
	if closewindow then
		if closewindow.x == nil then
			closewindow.x = closewindow.windowdefs.startx
			closewindow.y = closewindow.windowdefs.starty
		end
		if laptop.mousex <= closewindow.x+closewindow.windowdefs.width+(closewindow.windowdefs.bordersize/2) and laptop.mousex >= closewindow.x+closewindow.windowdefs.width+(closewindow.windowdefs.bordersize/2)-24 then
			if laptop.mousey >= closewindow.y+(closewindow.windowdefs.bordersize/2) and laptop.mousey <= closewindow.y+(closewindow.windowdefs.bordersize/2)+16 then
				return true
			end
		end
	elseif button then
		if button.clickfunction and window then
			return false
		end	
		if laptop.mousex >= button.x and laptop.mousex <= button.x + button.width and laptop.mousey >= button.y and laptop.mousey <= button.y + button.length then
			return true
		end
	end
	
	return false
end) 

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" and p.speccy then
			if p.speccy.laptop == nil then
				setupLaptop(p)
				shopButtonSetup(p)
				gcButtonSetup(p)
				settingsButtonSetup(p)
				p.speccy.usinglaptop = false
			elseif p.speccy.usinglaptop then
				if p.speccy.laptop == nil then
					return
				end
			
				if netgame then
					p.powers[pw_flashing] = 2*TICRATE
				else
					for mobj in mobjs.iterate() do
						if (mobj.flags & MF_BOSS) or (mobj.flags & MF_ENEMY) then
							mobj.flags = $|MF_NOTHINK
						end
					end
					p.powers[pw_flashing] = 5
				end
				
				p.pflags = $|PF_FULLSTASIS
			
				if p.speccy.laptop.controlstyle == 2 then
					p.speccy.laptop.mousex, p.speccy.laptop.mousey = input.getCursorPosition()
					if mouse.buttons & MB_BUTTON1 then
						p.speccy.laptop.mousedown = $ + 1
					else
						p.speccy.laptop.mousedown = 0
					end
				else
					if input.gameControlDown(GC_FORWARD) then
						p.speccy.laptop.mousey = $ - p.speccy.laptop.mousespeed
					elseif input.gameControlDown(GC_BACKWARD) then
						p.speccy.laptop.mousey = $ + p.speccy.laptop.mousespeed
					end
					
					if input.gameControlDown(GC_STRAFELEFT) then
						p.speccy.laptop.mousex = $ - p.speccy.laptop.mousespeed
					elseif input.gameControlDown(GC_STRAFERIGHT) then
						p.speccy.laptop.mousex = $ + p.speccy.laptop.mousespeed
					end
					
					if input.gameControlDown(GC_JUMP) then
						p.speccy.laptop.mousedown = $ + 1
					else
						p.speccy.laptop.mousedown = 0
					end
				end
			
				for i=1,#p.speccy.laptop.desktop do
					local item = p.speccy.laptop.desktop[i]
					if item.button then
						if checkHitbox(p.speccy.laptop, item, nil, p.speccy.laptop.windows[1]) and (p.speccy.laptop.mousedown == 1) then
							item.clickfunction(p)
						end
					end
				end
				
				for i=1,#p.speccy.laptop.windows do
					local window = p.speccy.laptop.windows[i]
					window.windowdefs.actionfunction(p, window)
					if p.speccy.laptop == nil then
						return
					end
					if p.speccy.laptop.windows[i] == nil then
						continue
					end
					if not p.speccy.laptop.windows[i].closebutton then
						return
					end
					if checkHitbox(p.speccy.laptop, nil, window, window) then
						window.closebutton.highlighted = true
						if p.speccy.laptop.mousedown then
							p.speccy.laptop.windows[i] = nil
						end
					else
						window.closebutton.highlighted = false
					end
				end
			end
			
			if p.cmd.buttons & BT_TOSSFLAG then
				p.speccy.laptopopentimer = $ + 1
			else
				p.speccy.laptopopentimer = 0
			end
			
			if p.speccy.usinglaptop and p.speccy.laptopopentimer == 1 then
				p.speccy.usinglaptop = false
				if not netgame then
					for mobj in mobjs.iterate() do
						if (mobj.flags & MF_BOSS) or (mobj.flags & MF_ENEMY) then
							mobj.flags = $ & ~MF_NOTHINK
						end
					end
				end
			elseif (not p.speccy.usinglaptop) and p.speccy.laptopopentimer == 1 then
				p.speccy.usinglaptop = true
			end
		end
	end
end)

hud.add(function(v, p)
	if p.mo and p.mo.valid then
		if p.mo.skin == "speccy" and p.speccy then
			if p.speccy.laptop and p.speccy.usinglaptop then
				if p.speccy.laptop.desktop.desktopdefs.backgroundstyle == "full" then
					v.draw(0, 0, v.cachePatch(p.speccy.laptop.desktop.desktopdefs.background), nil)
				elseif p.speccy.laptop.desktop.desktopdefs.backgroundstyle == "tile" then
					-- tiling code here
				end
				
				for i=1,#p.speccy.laptop.desktop do
					local item = p.speccy.laptop.desktop[i]
					
					if item.button then
						if item.patch then
							v.draw(item.x, item.y, v.cachePatch(item.patch))
						else 
							v.drawFill(item.x, item.y, item.width, item.length, item.color)
						end
						if item.align ~= "small-center" then
							v.drawString(item.x+(item.width/2), item.y+item.length+1, item.name, item.flags, item.align)
						else
							v.drawString(item.x+item.width+2, item.y+item.length+1, item.name, item.flags, item.align)
						end
					end
				end
				
				for i=1,#p.speccy.laptop.windows do
					local window = p.speccy.laptop.windows[i]
					
					if window.x == nil then
						window.x = window.windowdefs.startx
						window.y = window.windowdefs.starty
					end
					
					if window.windowdefs.borderless then
						window.windowdefs.drawfunction(v, p, window)
					else
						v.drawFill(window.x, window.y, window.windowdefs.width+window.windowdefs.bordersize, 16+window.windowdefs.length+window.windowdefs.bordersize, window.windowdefs.bordercolor)
						v.drawFill(window.x+window.windowdefs.bordersize/2, window.y+window.windowdefs.bordersize/2, window.windowdefs.width, 16, window.windowdefs.windowcolor)
						v.drawString(window.x+4+window.windowdefs.bordersize/2, window.y+4+window.windowdefs.bordersize/2, window.windowdefs.title, window.windowdefs.titlecolor)
						if window.closebutton.highlighted then
							v.drawFill(window.x+window.windowdefs.width+(window.windowdefs.bordersize/2)-24, window.y+(window.windowdefs.bordersize/2), 24, 16, window.closebutton.highlightcolor)
						else
							v.drawFill(window.x+window.windowdefs.width+(window.windowdefs.bordersize/2)-24, window.y+(window.windowdefs.bordersize/2), 24, 16, window.windowdefs.windowcolor)
						end
						v.drawString(window.x+window.windowdefs.width+(window.windowdefs.bordersize/2)-12, window.y+(window.windowdefs.bordersize/2)+4, window.closebutton.xmark, nil, "center")
						window.windowdefs.drawfunction(v, p, window)
					end
				end
				
				if p.speccy.laptop.windows[1] then
					if p.speccy.laptop.windows[1].windowdefs.title ~= "Nintendo GameCube - Startup" then
						v.drawString(p.speccy.laptop.mousex, p.speccy.laptop.mousey, p.speccy.laptop.cursor, nil)
					end
				else
					v.drawString(p.speccy.laptop.mousex, p.speccy.laptop.mousey, p.speccy.laptop.cursor, nil)
				end
			end
		end
	end
end, "game")